// Izlomljena.java - Klasa izlomljenih linija u ravni.

package linije;

public class Izlomljena extends Linija {
  
  protected Tacka[] tem;                 // Niz temena.
  
  public Izlomljena (Tacka[] niz)        // Inicijalizacija nizom tacaka.
      { kopiraj (niz); }

  protected void kopiraj (Tacka[] niz) { // Kopiranje u objekat.
    tem = new Tacka [niz.length];
    for (int i=0; i<tem.length; tem[i] = niz[i++].kopija());
  }

  public double duz () {                 // Duzina izlomljene linije.
    double d = 0;
    for (int i=0; i<tem.length-1; i++)
      d += new Duz(tem[i], tem[i+1]).duz();
    return d;
  }

  public Linija kopija ()                // Kopija izlomljene linije.
    { return  new Izlomljena (tem); }

  public String toString () {            // Tekstualni prikaz.
    return super.toString()  + "[izlomljena: " +
           Tacka.toString (tem) + "]";
  }
}