// Casovnik.java - Klasa casovnika.

package usluge;
import  java.util.Calendar;

public class Casovnik extends Thread {
  
  private boolean radi = false; // Da li nit treba da radi?
  private boolean kraj = false; // Da li nit treba da se zavrsi?
  private Polje datum, vreme;   // Polja za prikaz datuma i vremena.

  public Casovnik (Polje d, Polje v)        // Inicijalizacija.
    { vreme = v; datum = d; start (); }
  
  public void run () {                      // TELO NITI:
    while (!kraj) {
      if (!radi) {                          // - uslovno pauziranje niti,
        synchronized (this)
          { try { wait (); } catch (InterruptedException g) {} }
      }
    if (kraj) break;                        // - uslovni zavrsetak niti,
      Calendar t = Calendar.getInstance (); // - koristan rad,
      if (vreme != null) vreme.pisi(
        t.get(Calendar.HOUR_OF_DAY) + ":" +
        t.get(Calendar.MINUTE)      + ":" +
        t.get(Calendar.SECOND)
      );
      if (datum != null) datum.pisi(
        t.get(Calendar.DATE)  + "." +
        t.get(Calendar.MONTH) + "." +
        t.get(Calendar.YEAR)
      );
      try { Thread.sleep (1000); }           // - cekanje 1000 ms.
        catch (InterruptedException g) {}
    }
  }
  
  public void stani () { radi = false; }    // Privremeno zaustavljanje.
  
  public synchronized void kreni ()         // Nastavak rada.
    { if (!radi) { radi = true; notify (); } }
  
  public void zavrsi ()                     // Zavrsetak rada.
    { kraj = true; interrupt (); }
}