// Polje.java - Polje graficke korisnicke povrsi za unos i prikaz podataka.

package usluge;
import  java.awt.*;

public class Polje {
  
  private Component komp;             // Pridruzena graficka komponenta.
  private Component prozor;           // Roditeljski prozor.
  private int ind;                    // Indeks stavke u komponenti.
  
  public Polje (Component k, int i)   // Inicijalizacija.
    throws GPoljeNeOdgovara {
    if (!(k instanceof Label)     && 
        !(k instanceof TextField) &&
        !(k instanceof TextArea)  &&
        !(k instanceof List)
       ) throw new GPoljeNeOdgovara (k);
    komp = k; ind = i;
    prozor = komp.getParent ();
    while (prozor.getParent() != null) prozor = prozor.getParent();
  }
  public Polje (Component k) 
    throws GPoljeNeOdgovara { this (k, -1); }
    
  public Component komponenta ()      // Dohvatanje sadrzane komponente.
    { return komp; }

  public void pisi (String tekst) {   // Prikaz podatka tipa String.
    if      (komp instanceof Label) 
      ((Label)komp).setText (tekst);
    else if (komp instanceof TextComponent)
      ((TextComponent)komp).setText (tekst);
    else if (komp instanceof List)
      ((List)komp).replaceItem (tekst, ind);
      prozor.validate ();
  }
  
  public void pisi (long broj)        // Prikaz podatka tipa long.
    { pisi (Long.toString (broj)); }
  public void pisi (long broj, int baza)
    { pisi (Long.toString (broj, baza)); }

  public void pisi (double broj)      // Prikaz podatka tipa double.
    { pisi (Double.toString (broj)); }

  public void pisi (char znak)        // Prikaz podatka tipa char.
    { pisi (new Character (znak).toString ()); }

  public void pisi (boolean b)        // Prikaz podatka tipa boolean.
    { pisi (new Boolean(b).toString ()); }
  
  public String String () {           // Uzimanje podatka tipa String.
    if      (komp instanceof Label) 
      return ((Label)komp).getText ();
    else if (komp instanceof TextComponent)
      return ((TextComponent)komp).getText ();
    else if (komp instanceof List)
      return ((List)komp).getItem (ind);
    else return null;
  }
  
  public long Long ()                 // Uzimanje podatka tipa long.
    { return Long.parseLong (String ()); }
  public long Long (int baza)
    { return Long.parseLong (String (), baza); }
    
  public double Double ()             // Uzimanje podatka tipa double.
    { return Double.parseDouble (String ()); }
  
  public char Char ()                 // Uzimanje podatka tipa char.
    { return String ().charAt (0); }
    
  public boolean Boolean ()           // Uzimanje podatka tipa booelan.
    { return Boolean.parseBoolean (String ()); }
}